package io.renren.modules.sys.controller;

import io.renren.common.annotation.LogOperation;
import io.renren.common.constant.Constant;
import io.renren.common.page.PageData;
import io.renren.common.utils.ExcelUtils;
import io.renren.common.utils.Result;
import io.renren.common.validator.AssertUtils;
import io.renren.common.validator.ValidatorUtils;
import io.renren.common.validator.group.AddGroup;
import io.renren.common.validator.group.DefaultGroup;
import io.renren.common.validator.group.UpdateGroup;
import io.renren.modules.sys.dto.RdAccountLogDTO;
import io.renren.modules.sys.excel.RdAccountLogExcel;
import io.renren.modules.sys.service.RdAccountLogService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;


/**
 * 账号流水明细
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2022-06-03
 */
@RestController
@RequestMapping("sys/rdaccountlog")
@Api(tags="账号流水明细")
public class RdAccountLogController {
    @Autowired
    private RdAccountLogService rdAccountLogService;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("sys:rdaccountlog:page")
    public Result<PageData<RdAccountLogDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<RdAccountLogDTO> page = rdAccountLogService.page(params);

        return new Result<PageData<RdAccountLogDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("sys:rdaccountlog:info")
    public Result<RdAccountLogDTO> get(@PathVariable("id") Long id){
        RdAccountLogDTO data = rdAccountLogService.get(id);

        return new Result<RdAccountLogDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("sys:rdaccountlog:save")
    public Result save(@RequestBody RdAccountLogDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        rdAccountLogService.save(dto);

        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("sys:rdaccountlog:update")
    public Result update(@RequestBody RdAccountLogDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        rdAccountLogService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("sys:rdaccountlog:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");

        rdAccountLogService.delete(ids);

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("sys:rdaccountlog:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<RdAccountLogDTO> list = rdAccountLogService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, RdAccountLogExcel.class);
    }

    @GetMapping("refresh")
    @ApiOperation("刷新")
    @LogOperation("刷新")
    @RequiresPermissions("sys:rdaccountlog:refresh")
    public Result refresh(@RequestParam(required = false)String date){
        rdAccountLogService.refreshRdAccountLog(date,"RECHARGE");
        rdAccountLogService.refreshRdAccountLog(date,"TRANSFER");
        return new Result();
    }

}